package edu.uoc.android.socialplan.activities.planes;

import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.support.v4.content.res.ResourcesCompat;
import android.support.v4.graphics.drawable.DrawableCompat;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SearchView;
import android.widget.SeekBar;
import android.widget.TextView;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import edu.uoc.android.socialplan.R;
import edu.uoc.android.socialplan.application.BaseActivity;

/**
 * Created by alejandroresuagarcia on 18/11/17.
 */
public class SearchActivity extends BaseActivity {

    private static final String TAG = "SearchActivity";

    @BindView(R.id.toolbar) public Toolbar toolbar;
    @BindView(R.id.seekBar) SeekBar seekBar;
    @BindView(R.id.seekBar_tv) TextView seekBarTV;

    private int kilometres;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setSupportActionBar(toolbar);

        Drawable drawable = ResourcesCompat.getDrawable(getResources(), android.R.drawable.ic_menu_close_clear_cancel, null);
        drawable = DrawableCompat.wrap(drawable);
        DrawableCompat.setTint(drawable, Color.WHITE);

        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        int distance = getIntent().getIntExtra("distance", 100);
        kilometres = distance;

        seekBarTV.setText(getResources().getString(R.string.kilometros, String.valueOf(distance)));

        seekBar.setMax(999);
        seekBar.setProgress(distance); // Set it to zero so it will start at the left-most edge
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {

            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                progress = progress + 1; // Add the minimum value (1)
                kilometres = progress;
                seekBarTV.setText(getResources().getString(R.string.kilometros, String.valueOf(kilometres)));
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {}

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {}

        });
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == android.R.id.home) {
            // handle close button click here
            final Intent resultIntent = new Intent();
            resultIntent.putExtra("distance", kilometres);
            setResult(SearchActivity.RESULT_OK, resultIntent);
            finish();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public int getLayoutId() {
        return R.layout.activity_filter;
    }

}