package edu.uoc.android.socialplan.application;

import android.app.Application;
import android.content.Context;
import android.content.SharedPreferences;

import com.crashlytics.android.Crashlytics;
import com.firebase.geofire.GeoFire;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;

import org.greenrobot.greendao.database.Database;

import edu.uoc.android.socialplan.models.DaoMaster;
import edu.uoc.android.socialplan.models.DaoSession;
import io.fabric.sdk.android.Fabric;

/**
 * Created by aresua on 13/07/2017.
 */
public class App extends Application {

    private DaoSession daoSession;
    private Database db;
    private SharedPreferences prefs;
    private GeoFire geoFire;
    private DatabaseReference realtimeDB;

    @Override
    public void onCreate() {
        super.onCreate();

        Fabric.with(this, new Crashlytics());

        DaoMaster.DevOpenHelper helper = new DaoMaster.DevOpenHelper(this, "socialPlan-db");
        this.db = helper.getWritableDb();

        DaoMaster.createAllTables(db, true);

        daoSession = new DaoMaster(db).newSession();
        prefs = getSharedPreferences("socialPlanPreferences", Context.MODE_PRIVATE);

        realtimeDB = FirebaseDatabase.getInstance().getReference();
        geoFire = new GeoFire(realtimeDB);
    }

    public DaoSession getDaoSession() {
        return daoSession;
    }

    public Database getDb() {
        return db;
    }

    public SharedPreferences getPrefs() {
        return prefs;
    }

    public GeoFire getGeoFire() {
        return geoFire;
    }

    public DatabaseReference getRealtimeDB() {
        return realtimeDB;
    }


}