package edu.uoc.android.socialplan.application;

import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;

import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;

import butterknife.ButterKnife;
import edu.uoc.android.socialplan.models.DaoSession;

/**
 * Created by alejandroresuagarcia on 6/11/17.
 */

public abstract class BaseActivity extends AppCompatActivity {

    private FirebaseAuth mAuth;
    private DaoSession greendaoDb;
    private SharedPreferences prefs;
    private DatabaseReference realtimeDB;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(getLayoutId());
        ButterKnife.bind(this);

        mAuth = FirebaseAuth.getInstance();
        greendaoDb = ((App)getApplication()).getDaoSession();
        prefs = ((App)getApplication()).getPrefs();
        realtimeDB = ((App)getApplication()).getRealtimeDB();
    }

    public abstract int getLayoutId();

    public FirebaseAuth getmAuth() {
        return mAuth;
    }

    public DaoSession getGreendaoDb() {
        return greendaoDb;
    }

    public SharedPreferences getPrefs() {
        return prefs;
    }

    public DatabaseReference getRealtimeDB() {
        return realtimeDB;
    }
}
