package edu.uoc.android.socialplan.fragments;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.Snackbar;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.support.v4.content.res.ResourcesCompat;
import android.support.v4.graphics.drawable.DrawableCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.RecyclerView;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TabHost;
import android.widget.TextView;

import com.firebase.geofire.GeoFire;
import com.firebase.geofire.GeoLocation;
import com.firebase.geofire.LocationCallback;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.Query;
import com.google.firebase.database.ValueEventListener;
import com.kunzisoft.switchdatetime.SwitchDateTimeDialogFragment;
import com.squareup.picasso.Picasso;

import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import edu.uoc.android.socialplan.R;
import edu.uoc.android.socialplan.activities.general.MainActivity;
import edu.uoc.android.socialplan.activities.planes.PlacesSearchActivity;
import edu.uoc.android.socialplan.adapters.ComentariosRecyclerViewAdapter;
import edu.uoc.android.socialplan.application.App;
import edu.uoc.android.socialplan.constants.FirebaseDBEnum;
import edu.uoc.android.socialplan.constants.AdapterEnum;
import edu.uoc.android.socialplan.constants.TipoLoginUserEnum;
import edu.uoc.android.socialplan.constants.TipoNotificacionesEnum;
import edu.uoc.android.socialplan.models.Comentario;
import edu.uoc.android.socialplan.models.DaoSession;
import edu.uoc.android.socialplan.models.Plan;
import edu.uoc.android.socialplan.models.Usuario;
import edu.uoc.android.socialplan.utils.ImageUtils;
import edu.uoc.android.socialplan.utils.NotificationUtils;
import edu.uoc.android.socialplan.utils.ValidacionUtils;

/**
 * Created by alejandroresuagarcia on 13/11/17.
 */

public class DetallePlanFragment extends DialogFragment implements TabHost.OnTabChangeListener {

    @BindView(R.id.plan_image) ImageView planImage;
    @BindView(R.id.plan_title) EditText planTitle;
    @BindView(R.id.plan_place) TextView planPlace;
    @BindView(R.id.plan_date) TextView planDate;
    @BindView(R.id.plan_place_layout) RelativeLayout planPlaceLayout;
    @BindView(R.id.plan_date_layout) RelativeLayout planDateLayout;
    @BindView(R.id.plan_description) EditText planDescription;
    @BindView(R.id.plan_count) TextView planCount;
    @BindView(R.id.tab_host) TabHost tabs;
    @BindView(R.id.unirse_button) Button unirseButton;
    @BindView(R.id.comentarios_recycler_view) RecyclerView comentariosRV;
    @BindView(R.id.nuevo_comentario) EditText nuevoComentario;
    @BindView(R.id.user_image) ImageView userImage;
    @BindView(R.id.arrow_date) ImageView arrowDate;
    @BindView(R.id.arrow_place) ImageView arrowPlace;

    private DatabaseReference realtimeDB;
    private SharedPreferences prefs;
    private DaoSession daoSession;

    private ComentariosRecyclerViewAdapter comentariosAdapter;
    private List<Comentario> lista;

    private String type;
    private String typeLocation;
    private Plan plan;
    private String userId;
    private boolean unirse;
    private Date fecha;
    private int parentFragment;

    private int GALLERY = 1, CAMERA = 2, SEARCH = 3;
    private static final int MY_CAMERA_REQUEST_CODE = 100;
    private String userImageB64;
    private double latitud;
    private double longitud;
    private Usuario usuario;

    private static String TAG = "DetallePlanFragment";

    public DetallePlanFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        final View rootView = inflater.inflate(R.layout.fragment_detalle_plan, container, false);
        ButterKnife.bind(this, rootView);

        Drawable drawable = ResourcesCompat.getDrawable(getResources(), android.R.drawable.ic_menu_close_clear_cancel, null);
        drawable = DrawableCompat.wrap(drawable);
        DrawableCompat.setTint(drawable, Color.WHITE);

        ((MainActivity)getActivity()).toggle.setDrawerIndicatorEnabled(false);
        ((MainActivity)getActivity()).toggle.setHomeAsUpIndicator(drawable);
        ((MainActivity)getActivity()).toggle.syncState();

        AppCompatActivity activity = (AppCompatActivity) getActivity();
        activity.setSupportActionBar(((MainActivity)getActivity()).toolbar);
        activity.getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        ((MainActivity)getActivity()).getSupportActionBar().setTitle(getResources().getString(R.string.detalle));

        //Tabs
        this.prepareTabs();

        final Bundle bundle = getArguments();
        plan = (Plan) bundle.getSerializable("plan");
        type = bundle.getString("type");
        typeLocation = bundle.getString("typeLocation");
        parentFragment = bundle.getInt("parentFragment");

        prefs = ((App) getActivity().getApplication()).getPrefs();
        realtimeDB = ((App)getActivity().getApplication()).getRealtimeDB();
        daoSession = ((App)getActivity().getApplication()).getDaoSession();

        usuario = daoSession.getUsuarioDao().load(userId);

        planTitle.setText(plan != null ? plan.getTitle() : "");
        if(plan.getImage() != null){
            final Bitmap bitmap = ImageUtils.convert(plan != null ? plan.getImage() : "");
            planImage.setImageBitmap(bitmap);
        }
        planDate.setText(this.getDate(plan != null ? plan.getDate() : new Date()));
        planDescription.setText(plan != null ? plan.getDescription() : "");

        if(FirebaseDBEnum.GRUPOS.getType().equals(type)){
            planCount.setText(getResources().getString(R.string.asistiran,
                    String.valueOf(plan.getUsersCount()),
                    String.valueOf(plan.getUsersMax())));
        }else{
            planCount.setText(getResources().getString(R.string.likes, String.valueOf(plan.getUsersCount())));
        }

        this.getPlace();

        this.comentariosAdapter = new ComentariosRecyclerViewAdapter(getContext(), new ArrayList<Comentario>());
        comentariosRV.setAdapter(this.comentariosAdapter);

        userId = prefs.getString("userId", "");
        //Comprobar para hacer clicable los edittext (cambiarlos);

        if(userId.equals(plan.getUserId())){
            planDescription.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                }

                @Override
                public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                    planDescription.setCompoundDrawables(null,null,null,null);
                }

                @Override
                public void afterTextChanged(Editable editable) {

                }
            });
            planTitle.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                }

                @Override
                public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                    planTitle.setCompoundDrawables(null,null,null,null);
                }

                @Override
                public void afterTextChanged(Editable editable) {

                }
            });
        }else{
            planTitle.setFocusable(false);
            planTitle.setClickable(false);
            planDescription.setFocusable(false);
            planDescription.setClickable(false);
            planDescription.setKeyListener(null);
            planDate.setFocusable(false);
            planDate.setClickable(false);
            planPlace.setFocusable(false);
            planPlace.setClickable(false);
            planImage.setFocusable(false);
            planImage.setClickable(false);
            planDateLayout.setClickable(false);
            planPlaceLayout.setClickable(false);
            arrowDate.setVisibility(View.GONE);
            arrowPlace.setVisibility(View.GONE);
        }

        if(!FirebaseDBEnum.GRUPOS.getType().equals(type)
                || userId.equals(plan.getUserId())){
            unirseButton.setVisibility(View.GONE);
        }else{
            if(plan.getUsersMax() == plan.getUsersCount()){
                unirseButton.setVisibility(View.GONE);
            }else{
                unirseButton.setVisibility(View.VISIBLE);
            }

            final DatabaseReference reference = realtimeDB.child(type).child(plan.getId()).child(FirebaseDBEnum.USUARIOS.getType());
            final Query query = reference.child(userId);
            query.addListenerForSingleValueEvent(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    if(dataSnapshot.exists()){
                        unirseButton.setText(getResources().getString(R.string.salir_grupo));
                        unirse = false;
                        if(plan.getUsersMax() == plan.getUsersCount()){
                            unirseButton.setVisibility(View.VISIBLE);
                        }
                    }else{
                        unirseButton.setText(getResources().getString(R.string.unirse));
                        unirse = true;
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {
                    System.out.println("onCancelled");
                    unirseButton.setVisibility(View.VISIBLE);
                }
            });
        }

        return rootView;
    }

    private void prepareTabs(){
        tabs.setup();

        TabHost.TabSpec spec=tabs.newTabSpec("informacion");
        spec.setContent(R.id.tab_informacion);
        spec.setIndicator(getResources().getString(R.string.informacion));
        tabs.addTab(spec);

        spec=tabs.newTabSpec("comentarios");
        spec.setContent(R.id.tab_comentarios);
        spec.setIndicator(getResources().getString(R.string.comentarios));
        tabs.addTab(spec);

        tabs.setOnTabChangedListener(this);

        tabs.setCurrentTab(0);
    }

    @Override
    public void onTabChanged(String s) {
        if(s.equals("informacion")){
            Log.d(TAG, s);
        }else{
            Log.d(TAG, s);
            final Usuario usuario = daoSession.getUsuarioDao().load(userId);
            if(usuario.getPhoto() != null){
                if(usuario.getLoginType() != null
                        && usuario.getLoginType() == TipoLoginUserEnum.FACEBOOK.getId()) {
                    Picasso.with(getContext()).load(usuario.getPhoto()).into(userImage);
                }else{
                    final Bitmap bitmap = ImageUtils.convert(usuario.getPhoto());
                    userImage.setImageBitmap(bitmap);
                }
            }

            final Query queryPlans = realtimeDB.child(FirebaseDBEnum.COMENTARIOS.getType()).child(plan.getId()).orderByChild("date/time");
            final Query query = realtimeDB.child(FirebaseDBEnum.COMENTARIOS.getType()).child(plan.getId());
            query.addValueEventListener(new ValueEventListener() {
                @Override
                public void onDataChange(DataSnapshot dataSnapshot) {
                    lista = new ArrayList<>();
                    for (DataSnapshot postSnapshot : dataSnapshot.getChildren()) {
                        Comentario comentario = postSnapshot.getValue(Comentario.class);
                        lista.add(comentario);
                    }
                    if (!lista.isEmpty()) {
                        Collections.reverse(lista);
                        comentariosAdapter.addItem(lista);
                    }
                }

                @Override
                public void onCancelled(DatabaseError databaseError) {
                    System.out.println("onCancelled");
                }
            });

            nuevoComentario.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                }

                @Override
                public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                    nuevoComentario.setCompoundDrawables(null,null,null,null);
                }

                @Override
                public void afterTextChanged(Editable editable) {

                }
            });
        }
    }

    private String getDate(Date date){
        final String myFormat = getResources().getString(R.string.date_mask); //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, new Locale("es"));
        return sdf.format(date);
    }

    private void getPlace(){
        final GeoFire geoFire = new GeoFire(realtimeDB.child(typeLocation));
        geoFire.getLocation(plan.getId(), new LocationCallback() {
            @Override
            public void onLocationResult(String key, GeoLocation location) {
                final Geocoder geo = new Geocoder(getContext());
                try {
                    final List<Address> lista = geo.getFromLocation(location.longitude, location.latitude, 1);
                    if(lista != null
                            && !lista.isEmpty()){
                        if(lista.get(0).getPremises() != null
                                && !"".equals(lista.get(0).getPremises())){
                            planPlace.setText(lista.get(0).getPremises());
                        }else{
                            planPlace.setText(lista.get(0).getLocality());
                        }
                    }

                    plan.setLatitud(location.latitude);
                    plan.setLongitud(location.longitude);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });
    }

    @OnClick(R.id.unirse_button)
    public void unirseAction(View view) {
        usuario = daoSession.getUsuarioDao().load(userId);

        if(unirse){
            //Se añade el usuario al evento confirmando asistencia
            DatabaseReference reference = realtimeDB.child(type)
                    .child(plan.getId()).child(FirebaseDBEnum.USUARIOS.getType());
            Map<String, Object> childUpdates = new HashMap<>();
            childUpdates.put(userId, true);
            reference.updateChildren(childUpdates);

            //Se añade un usuario al evento
            childUpdates = new HashMap<>();
            int usersCount = plan.getUsersCount();
            usersCount += 1;
            childUpdates.put("usersCount", usersCount);
            realtimeDB.child(type).child(plan.getId()).updateChildren(childUpdates);
            plan.setUsersCount(usersCount);

            unirseButton.setText(getResources().getString(R.string.salir_grupo));
            unirse = false;

            final String sb = getResources().getString(R.string.evento_unir, usuario.getName(), plan.getTitle());
            NotificationUtils.sendNotificationToUser(plan.getUserId(), sb, TipoNotificacionesEnum.JOIN.getId(), realtimeDB, daoSession);
        }else{
            //Se elimina el usuario al evento confirmando asistencia
            DatabaseReference reference = realtimeDB.child(type)
                    .child(plan.getId()).child(FirebaseDBEnum.USUARIOS.getType()).child(userId);
            reference.removeValue();

            //Se substrae un usuario al evento
            Map<String, Object> childUpdates = new HashMap<>();
            int usersCount = plan.getUsersCount();
            usersCount -= 1;
            childUpdates.put("usersCount", usersCount);
            realtimeDB.child(type).child(plan.getId()).updateChildren(childUpdates);
            plan.setUsersCount(usersCount);

            unirseButton.setText(getResources().getString(R.string.unirse));
            unirse = true;
        }
    }

    @OnClick(R.id.enviar_comentario)
    public void enviarAction(View view) {
        usuario = daoSession.getUsuarioDao().load(userId);

        if(ValidacionUtils.isRequired(nuevoComentario.getText().toString())){
            final Comentario comentario = new Comentario();
            comentario.setComentario(nuevoComentario.getText().toString());
            if(usuario != null && usuario.getPhoto() != null){
                comentario.setUserImage(usuario.getPhoto());
            }
            comentario.setUserName(usuario.getName());
            comentario.setLoginType(usuario.getLoginType());
            String comentId = "0";
            if(lista != null){
                comentId = String.valueOf(lista.size());
            }
            comentario.setId(usuario.getId() + "-" + comentId);
            comentario.setDate(new Date());
            comentario.setPlanId(plan.getId());

            // Añadir nuevo usuario
            realtimeDB.child(FirebaseDBEnum.COMENTARIOS.getType())
                    .child(plan.getId())
                    .child(comentario.getId())
                    .setValue(comentario);

            daoSession.getComentarioDao().insertOrReplace(comentario);

            nuevoComentario.setText("");

            if(!userId.equals(plan.getUserId())){
                final String sb = getResources().getString(R.string.evento_coment, usuario.getName(), plan.getTitle());
                NotificationUtils.sendNotificationToUser(plan.getUserId(), sb, TipoNotificacionesEnum.COMENT.getId(), realtimeDB, daoSession);
            }

            if (view != null) {
                InputMethodManager imm = (InputMethodManager)getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
            }

            Snackbar.make(view, getResources().getString(R.string.comentario_enviado), Snackbar.LENGTH_LONG).show();

        }else{
            ValidacionUtils.hayErrorEditText(getResources(), nuevoComentario);
            Snackbar.make(view, getResources().getString(R.string.validacion_error), Snackbar.LENGTH_LONG).show();
        }
    }

    @OnClick(R.id.plan_image)
    public void userImageButton(View view) {
        AlertDialog.Builder pictureDialog = new AlertDialog.Builder(getContext());
        pictureDialog.setTitle(getResources().getString(R.string.seleccionar_opcion));
        String[] pictureDialogItems = {
                getResources().getString(R.string.seleccionar_foto),
                getResources().getString(R.string.camara) };
        pictureDialog.setItems(pictureDialogItems, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                switch (which) {
                    case 0:
                        choosePhotoFromGallery();
                        break;
                    case 1:
                        takePhotoFromCamera();
                        break;
                }
            }
        });
        pictureDialog.show();
    }

    public void choosePhotoFromGallery() {
        final Intent photoPickerIntent = new Intent(Intent.ACTION_GET_CONTENT);
        photoPickerIntent.setType("image/*");
        startActivityForResult(photoPickerIntent, GALLERY);
    }

    private void takePhotoFromCamera() {
        if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.CAMERA)
                == PackageManager.PERMISSION_DENIED){
            requestPermissions(new String[] {Manifest.permission.CAMERA}, MY_CAMERA_REQUEST_CODE);
        }else{
            final Intent intent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
            startActivityForResult(intent, CAMERA);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        switch (requestCode) {
            case MY_CAMERA_REQUEST_CODE: {
                if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.CAMERA)
                        == PackageManager.PERMISSION_GRANTED) {
                    final Intent intent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
                    startActivityForResult(intent, CAMERA);
                } else {
                    Log.d(TAG, "Deny permission");
                }
            }
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == Activity.RESULT_CANCELED) {
            return;
        }
        if (requestCode == GALLERY) {
            if (data != null) {
                Uri contentURI = data.getData();
                try {
                    final InputStream imageStream = getContext().getContentResolver().openInputStream(contentURI);
                    Bitmap bitmap = BitmapFactory.decodeStream(imageStream);
                    bitmap=Bitmap.createScaledBitmap(bitmap, 200, 200, true);
                    planImage.setImageBitmap(bitmap);
                    userImageB64 = ImageUtils.convert(bitmap);

                    if(userImageB64 != null){
                        plan.setImage(userImageB64);
                    }
                    realtimeDB.child(type).child(plan.getId()).updateChildren(plan.toMap());
                    Snackbar.make(getView(), getResources().getString(R.string.foto_plan_act), Snackbar.LENGTH_LONG).show();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        } else if (requestCode == CAMERA) {
            Bitmap thumbnail = (Bitmap) data.getExtras().get("data");
            planImage.setImageBitmap(thumbnail);
            userImageB64 = ImageUtils.convert(thumbnail);

            if(userImageB64 != null){
                plan.setImage(userImageB64);
            }
            realtimeDB.child(type).child(plan.getId()).updateChildren(plan.toMap());
            Snackbar.make(getView(), getResources().getString(R.string.foto_plan_act), Snackbar.LENGTH_LONG).show();

        }else if(requestCode == SEARCH){
            String lugar = (String)data.getExtras().get("lugar");
            planPlace.setText(lugar);
            latitud = (double)data.getExtras().get("latitud");
            longitud = (double)data.getExtras().get("longitud");

            if(latitud != 0.0
                    && longitud != 0.0){
                GeoFire geoFire = new GeoFire(realtimeDB.child(typeLocation));
                geoFire.setLocation(plan.getId(), new GeoLocation(longitud, latitud));
                Snackbar.make(getView(), getResources().getString(R.string.lugar_plan_act), Snackbar.LENGTH_LONG).show();
            }
            Log.d(TAG, lugar);
        }
    }

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        Dialog dialog = super.onCreateDialog(savedInstanceState);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        return dialog;
    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        menu.clear();
        if(userId.equals(plan.getUserId())){
            getActivity().getMenuInflater().inflate(R.menu.menu_dialog, menu);

            MenuItem favoriteItem = menu.findItem(R.id.action_save);
            Drawable newIcon = (Drawable)favoriteItem.getIcon();
            newIcon.mutate().setColorFilter(Color.WHITE, PorterDuff.Mode.SRC_IN);
            favoriteItem.setIcon(newIcon);
            newIcon.mutate().setColorFilter(getResources().getColor(R.color.white), PorterDuff.Mode.SRC_IN);

        }
        super.onCreateOptionsMenu(menu, inflater);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        final Bundle bundle = new Bundle();
        bundle.putInt("parentFragment", parentFragment);
        Fragment fragment;
        if(parentFragment == AdapterEnum.HOME_EVENTOS.getId()
                || parentFragment == AdapterEnum.HOME_GRUPOS.getId()){
            fragment = new HomeFragment();
        }else{
            fragment = new RedFragment();
        }
        fragment.setArguments(bundle);

        if (id == R.id.action_save) {
            // handle confirmation button click here
            modifyPlan(fragment);
            return true;
        } else if (id == android.R.id.home) {
            // handle close button click here
            switchContent(fragment);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private void modifyPlan(final Fragment fragment){
        AlertDialog.Builder builder;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            builder = new AlertDialog.Builder(getContext(), android.R.style.Theme_Material_Dialog_Alert);
        } else {
            builder = new AlertDialog.Builder(getContext());
        }
        builder.setTitle(getResources().getString(R.string.informacion))
                .setMessage(getResources().getString(R.string.modificar_plan_info))
                .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        boolean error = false;
                        if(!ValidacionUtils.isRequired(planTitle.getText().toString())){
                            ValidacionUtils.hayErrorEditText(getResources(), planTitle);
                            error = true;
                        }

                        if(!ValidacionUtils.isRequired(planDescription.getText().toString())){
                            ValidacionUtils.hayErrorEditText(getResources(), planDescription);
                            error = true;
                        }

                        if(error){
                            Snackbar.make(getView(), getResources().getString(R.string.validacion_error), Snackbar.LENGTH_LONG).show();
                        }else{
                            plan.setTitle(planTitle.getText().toString());
                            plan.setDescription(planDescription.getText().toString());
                            if(fecha != null){
                                plan.setDate(fecha);
                            }
                            realtimeDB.child(type).child(plan.getId()).updateChildren(plan.toMap());

                            Snackbar.make(getView(), getResources().getString(R.string.actualizado), Snackbar.LENGTH_LONG).show();

                            switchContent(fragment);
                        }
                    }
                })
                .setNegativeButton(getResources().getString(R.string.cancelar), new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        //Do not anything
                    }
                })
                .setIcon(android.R.drawable.ic_dialog_alert)
                .show();
    }

    private void updateLabel(Date date) {
        final String myFormat = getResources().getString(R.string.date_mask); //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, new Locale("es"));
        planDate.setText(sdf.format(date));
        fecha = date;
    }

    private void switchContent(Fragment fragment) {
        MainActivity mainActivity = (MainActivity) getContext();
        mainActivity.switchFragment(fragment);
    }

    @OnClick(R.id.plan_place_layout)
    public void planPlaceLayout(View view) {
        final Intent intent = new Intent(getActivity(), PlacesSearchActivity.class);
        startActivityForResult(intent, SEARCH);
    }

    @OnClick(R.id.plan_date_layout)
    public void planDateLayout(View view) {
        // Initialize
        final SwitchDateTimeDialogFragment dateTimeDialogFragment = SwitchDateTimeDialogFragment.newInstance(
                "",
                getResources().getString(R.string.aceptar),
                getResources().getString(R.string.cancelar)
        );

        // Assign values
        dateTimeDialogFragment.startAtCalendarView();
        dateTimeDialogFragment.set24HoursMode(true);
        dateTimeDialogFragment.setDefaultDateTime(new Date());
        dateTimeDialogFragment.setDefaultHourOfDay(0);
        dateTimeDialogFragment.setDefaultMinute(0);

        // Set listener
        dateTimeDialogFragment.setOnButtonClickListener(new SwitchDateTimeDialogFragment.OnButtonClickListener() {
            @Override
            public void onPositiveButtonClick(Date date) {
                updateLabel(date);
            }

            @Override
            public void onNegativeButtonClick(Date date) {
                dateTimeDialogFragment.dismiss();
            }
        });

        dateTimeDialogFragment.show(getFragmentManager(), "dialog_time");
    }
}
