package edu.uoc.android.socialplan.models;

import com.google.firebase.database.Exclude;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;

import java.io.Serializable;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.greenrobot.greendao.annotation.Generated;
import org.greenrobot.greendao.annotation.Transient;

/**
 * Created by alejandroresuagarcia on 14/11/17.
 */
@Entity
public class Plan implements Serializable {

    @Exclude
    private static final long serialVersionUID = 1L;

    @Id
    private String id;
    @Transient
    private String title;
    @Transient
    private String image;
    @Transient
    private String description;
    @Transient
    private Date date;
    @Transient
    private String place;
    @Transient
    private String userId;
    @Transient
    private int usersMax;
    @Transient
    private int usersCount;
    private int planType;
    @Transient
    private double latitud;
    @Transient
    private double longitud;
    @Transient
    private List<String> hash;




    @Generated(hash = 1382234819)
    public Plan(String id, int planType) {
        this.id = id;
        this.planType = planType;
    }



    @Generated(hash = 592612124)
    public Plan() {
    }



    public Map<String, Object> toMap() {
        HashMap<String, Object> result = new HashMap<>();
        result.put("id", id);
        result.put("title", title);
        result.put("image", image);
        result.put("description", description);
        result.put("date", date);
        result.put("place", place);
        result.put("userId", userId);
        result.put("usersCount", usersCount);
        result.put("usersMax", usersMax);

        return result;
    }



    public String getId() {
        return this.id;
    }



    public void setId(String id) {
        this.id = id;
    }



    public String getTitle() {
        return this.title;
    }



    public void setTitle(String title) {
        this.title = title;
    }



    public String getImage() {
        return this.image;
    }



    public void setImage(String image) {
        this.image = image;
    }



    public String getDescription() {
        return this.description;
    }



    public void setDescription(String description) {
        this.description = description;
    }



    public Date getDate() {
        return this.date;
    }



    public void setDate(Date date) {
        this.date = date;
    }



    public String getPlace() {
        return this.place;
    }



    public void setPlace(String place) {
        this.place = place;
    }



    public String getUserId() {
        return this.userId;
    }



    public void setUserId(String userId) {
        this.userId = userId;
    }



    public int getUsersMax() {
        return this.usersMax;
    }



    public void setUsersMax(int usersMax) {
        this.usersMax = usersMax;
    }



    public int getUsersCount() {
        return this.usersCount;
    }



    public void setUsersCount(int usersCount) {
        this.usersCount = usersCount;
    }



    public int getPlanType() {
        return this.planType;
    }



    public void setPlanType(int planType) {
        this.planType = planType;
    }



    public double getLatitud() {
        return this.latitud;
    }



    public void setLatitud(double latitud) {
        this.latitud = latitud;
    }



    public double getLongitud() {
        return this.longitud;
    }



    public void setLongitud(double longitud) {
        this.longitud = longitud;
    }

    public List<String> getHash() {
        return hash;
    }

    public void setHash(List<String> hash) {
        this.hash = hash;
    }
}
