package edu.uoc.android.socialplan.utils;

import android.content.Context;

import edu.uoc.android.socialplan.views.CustomProgressBarDialog;

/**
 * Created by aresua on 09/08/2017.
 */

public class GeneralUtils {

    private static CustomProgressBarDialog PROGRESS_BAR;

    private GeneralUtils() {
        // This utility class is not publicly instantiable
    }

    public static CustomProgressBarDialog getCustomProgressBarDialog(Context context){
        GeneralUtils.PROGRESS_BAR = new CustomProgressBarDialog(context);
        return GeneralUtils.PROGRESS_BAR;
    }

    /**
     * Checks if these coordinates are valid geo coordinates.
     * @param latitude The latitude must be in the range [-90, 90]
     * @param longitude The longitude must be in the range [-180, 180]
     * @return True if these are valid geo coordinates
     */
    public static boolean coordinatesValid(double latitude, double longitude) {
        return latitude >= -90 && latitude <= 90 && longitude >= -180 && longitude <= 180;
    }

}
