package edu.uoc.android.socialplan.utils;

import com.google.firebase.database.DatabaseReference;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import edu.uoc.android.socialplan.application.App;
import edu.uoc.android.socialplan.constants.FirebaseDBEnum;
import edu.uoc.android.socialplan.models.DaoSession;
import edu.uoc.android.socialplan.models.Notificacion;

/**
 * Created by alejandroresuagarcia on 2/12/17.
 */

public class NotificationUtils {

    public static void sendNotificationToUser(String user, final String message, final int type, DatabaseReference realtimeDB, DaoSession daoSession) {
        final Notificacion notificacion = new Notificacion();
        notificacion.setName(user);
        notificacion.setText(message);
        notificacion.setType(type);
        notificacion.setDate(new Date());

        final String notificacionId = realtimeDB.child(FirebaseDBEnum.NOTIFICACIONES.getType()).push().getKey();
        notificacion.setId(notificacionId);

        realtimeDB.child(FirebaseDBEnum.NOTIFICACIONES.getType()).child(notificacionId).setValue(notificacion);

        daoSession.getNotificacionDao().insertOrReplace(notificacion);
    }

}

