package edu.uoc.android.socialplan.utils;

import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.support.v4.graphics.drawable.DrawableCompat;
import android.text.TextUtils;
import android.util.Patterns;
import android.widget.EditText;
import android.widget.TextView;

import edu.uoc.android.socialplan.R;

/**
 * Created by alejandroresuagarcia on 1/12/17.
 */

public class ValidacionUtils {

    public static boolean isValidEmail(String email) {
        boolean isValid = true;
        if (TextUtils.isEmpty(email)) {
            isValid = false;
        }

        if (!Patterns.EMAIL_ADDRESS.matcher(email).matches()) {
            isValid = false;
        }
        return isValid;
    }

    public static boolean isRequired(String field) {
        boolean isValid = true;
        if (TextUtils.isEmpty(field)) {
            isValid = false;
        }

        return isValid;
    }

    public static boolean isEqual(String field, String field2) {
        boolean isValid = true;
        if (!TextUtils.isEmpty(field)
                && !TextUtils.isEmpty(field2)
                && !field.equals(field2)) {
            isValid = false;
        }

        return isValid;
    }

    public static void hayErrorEditText(Resources resources, EditText edittext){
        Drawable dr = resources.getDrawable(R.drawable.ic_error);
        DrawableCompat.setTint(dr, Color.RED);
        dr.setBounds(0, 0, 28, 28);
        edittext.setCompoundDrawables(null,null,dr,null);
    }

    public static void hayErrorTextView(Resources resources, TextView textView){
        Drawable dr = resources.getDrawable(R.drawable.ic_error);
        DrawableCompat.setTint(dr, Color.RED);
        dr.setBounds(0, 0, 28, 28);
        textView.setCompoundDrawables(null,null,dr,null);
    }
}
