
//import firebase functions modules
const functions = require('firebase-functions');
//import admin module
const admin = require('firebase-admin');
admin.initializeApp(functions.config().firebase);


// Listens for new messages added to messages/:pushId
exports.pushNotification = functions.database.ref('/messages/{pushId}').onWrite( event => {

    console.log('Push notification event triggered');

    //  Grab the current value of what was written to the Realtime Database.
    var valueObject = event.data.val();

  // Create a notification
    const payload = {
        notification: {
            title: "socialPlan",
            body: valueObject.text,
            sound: "default"
        },
    };

  //Create an options object that contains the time to live for the notification and the priority
    const options = {
        priority: "high",
        timeToLive: 60 * 60 * 24
    };

    return admin.messaging().sendToTopic("pushNotifications_"+valueObject.name, payload, options);
});


/*
var firebase = require('firebase-admin');
var request = require('request');

var API_KEY = "AAAA5ZgZrkI:APA91bFgVoXtS4Hm7S8egOx-NW_MBtSWjlmWFbdP_jHTR0cN1osp_X2Pxj7CvtShOCG3AKB63v6yElkotNuKzErxT5itORVSQdUw74IrGgiiyE81492MJHzXDBhhmdBRsLXNM3iSGXWx"; // Your Firebase Cloud Messaging Server API key

// Fetch the service account key JSON file contents
var serviceAccount = require("serviceAccountKey.json");

// Initialize the app with a service account, granting admin privileges
firebase.initializeApp({
  credential: firebase.credential.cert(serviceAccount),
  databaseURL: "https://socialplan-5cace.firebaseio.com"
});
ref = firebase.database().ref();

function listenForNotificationRequests() {
  var requests = ref.child('messages');
  requests.on('child_added', function(requestSnapshot) {
    var request = requestSnapshot.val();
    sendNotificationToUser(
      request.name, 
      request.text,
      function() {
        requestSnapshot.ref.remove();
      }
    );
  }, function(error) {
    console.error(error);
  });
};


function sendNotificationToUser(username, message, onSuccess) {
  request({
    url: 'https://fcm.googleapis.com/fcm/send',
    method: 'POST',
    headers: {
      'Content-Type' :' application/json',
      'Authorization': 'key='+API_KEY
    },
    body: JSON.stringify({
      "notification" : {
        "title": sender,
        "text": message
      },
      to : '/topics/user_'+username
    })
  }, function(error, response, body) {
    if (error) { console.error(error); }
    else if (response.statusCode >= 400) { 
      console.error('HTTP Error: '+response.statusCode+' - '+response.statusMessage); 
    }
    else {
      onSuccess();
    }
  });
}

// start listening
listenForNotificationRequests();
*/